/* ClientSocket.h

java-like implementation of sockets.

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Peter Dikant <peter.dikant@mobilexag.de>

This file is distributed under the GPL, see file COPYING for details. */

#ifndef __clientsocket_h__
#define __clientsocket_h__

#ifdef LINUX
typedef int SOCKET;
const int SOCKET_ERROR = -1;
const int INVALID_SOCKET = -1;
#else
#ifndef __windows_h_included__
#define __windows_h_included__
#include <windows.h>
#endif
#endif

class CServerSocket;

class CClientSocket  
{
	friend CServerSocket;
public:
	bool establishConnection();
	CClientSocket(SOCKET client);
	CClientSocket(const char *host, int port);
	virtual ~CClientSocket();
	int print(const char* line);
	int myprintf(const char *line, ...);
	void readLine (char* buffer, int bufferSize);
	void readLine (char* buffer);
	char* getHost() {return host;};
	int getBlock(char *buffer, int size);
private:
	char* host;
	int port;
	SOCKET client;
};

#endif __clientsocket_h__
