#include "TextToSpeech.h"
#include "../config.h"
#ifdef HAVE_SAPI_H
#include "MSSapi.cpp"
#endif
#ifdef HAVE_REALSPEAK_H
#include "RealSpeak.cpp"
#endif
#ifdef HAVE_FESTIVAL
#include "Festival.cpp"
#endif

TextToSpeech* TextToSpeech::getImplementation(Logger*log)
{
#ifdef HAVE_REALSPEAK_H
    return new RealSpeak(log, ".\\Engine");
#else
# ifdef HAVE_SAPI_H
	return new MSSapi(log);
# else
#  ifdef HAVE_FESTIVAL
	return new Festival(log);
#  else
	return new TextToSpeech(log);
#  endif
# endif
#endif
}

void TextToSpeech::setParams (const char *key, const char *value)
{
    log->logf("<warning> No Text to Speech engine active");
    return;
}
void TextToSpeech::text2Stream (const char *text, unsigned char **outbuffer, unsigned long *size)
{
    *outbuffer = 0;
    *size = 0;
    log->logf("<warning> No Text to Speech engine active");
    return;
}
void TextToSpeech::text2File (const char *text, const char *filename)
{
    log->logf("<warning> No Text to Speech engine active");
    return;
}
void TextToSpeech::text2Audio (const char *text)
{
    log->logf("<warning> No Text to Speech engine active");
    return;
}

TextToSpeech::TextToSpeech(Logger *log)
{
    this->log = log;
    return;
}

TextToSpeech::~TextToSpeech()
{
    return;
}
