/* Log.h

Header for Log.cpp

Part of the caiviar package. 

Copyright (c) 2002 MobileX AG, http://www.mobilexag.de
Copyright (c) 2002 Matthias Kramm <kramm@quiss.org>

This file is distributed under the GPL, see file COPYING for details. */


#if !defined(AFX_LOG_H__1237CA67_0D20_14A5_810E_AEF6F7182744__INCLUDED_)
#define AFX_LOG_H__1237CA67_0D20_14A5_810E_AEF6F7182744__INCLUDED_

#ifdef LINUX
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <pthread.h>
#else
#include <stdio.h>
#include <time.h>
#ifndef __windows_h_included__
#define __windows_h_included__
#include <windows.h>
#endif
#endif

#define LOGLEVEL_FATAL 0
#define LOGLEVEL_ERROR 1
#define LOGLEVEL_WARNING 2
#define LOGLEVEL_NOTICE 3
#define LOGLEVEL_VERBOSE 4
#define LOGLEVEL_DEBUG 5

class Logger {
public:
    ~Logger();
    void log(char* logString);
    void logf(const char* logFormat, ...);
    void initLog(char* pLogDir, int fileloglevel, char* servAddr, char* logPort, int serverloglevel, int screenloglevel);
    void exitLog(void);
private:
    int screenloglevel;
    int fileloglevel;
    int serverloglevel;
    FILE *logFile;
#if defined(LINUX)
    pthread_mutex_t log_mutex;
    int logSocket;
#elif defined(WIN32)
    CRITICAL_SECTION log_mutex;
    SOCKET logSocket;
#endif
    bool bLogToSock;

   void initlogSocket(char* servAddr, char* logPort);
};


#endif // !AFX_LOG_H__1237CA67_0D20_14A5_810E_AEF6F7182744__INCLUDED_
